//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 10;
    static final int MaxDB = 10000000;

    static class Input {
        int N;
    }

    static class Output {
        int Db;
        int[] x = new int[MaxN];
        int[][] Y = new int[MaxDB][MaxN];
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
        return input;
    }

    static void kiir(IO io, Input input, Output output) throws IOException {
        for (int i = 0; i < output.Db; i++) {
            for (int j = 0; j < input.N; j++) {
                io.write(output.Y[i][j] + " ");
            }
            io.writeLn("");
        }

    }

    static boolean Volt(int i, int j, int[] x) {
        int k = 1;
        while ((k < i) && (x[k - 1] != j)) {
            k++;
        }
        return (k < i);
    }

    static void Osszes_sorrend(int i, Input input, Output output) {
        if (i > input.N) {
            for (int j = 0; j < input.N; j++) {    // y[db] = x;
                output.Y[output.Db][j] = output.x[j];
            }
            output.Db++;
        } else {
            for (int j = 1; j <= input.N; j++) {
                if (!Volt(i, j, output.x)) {
                    output.x[i - 1] = j;
                    Osszes_sorrend(i + 1, input, output);
                }
            }
        }
    }

    static Output megold(Input input) {
        Output output = new Output();
        output.Db = 0;
        Osszes_sorrend(1, input, output);
        return output;
    }

    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);

        Output output = megold(input);

        kiir(io, input, output);

        io.close();
    }

}